
/**
 * XULSchoolChrome namespace.
 */
if ("undefined" == typeof(zMembre)) {
  var zMembre = {
	doc : null,
    getSrc : function(str) {
		var colors = ["", "008040", "BBBBBB", "804000", "AA3030", "8000ff", "", "47a1cf"];
		var BLUE = 5, BLACK = 7;
		var keysWords = ["auto", "break", "case", "char", "const", "continue", "default", "double", "do", "else", "enum", "extern", "float", "for", "goto", "if", "inline", "int", "long", "register", "restrict", "return", "short", "signed", "sizeof", "static", "struct", "switch", "typedef", "union", "unsigned", "void", "volatile", "while"];
		var colorKW   = [BLUE,   BLACK,   BLACK,   BLUE,   BLUE,   BLUE,        BLACK,     BLUE,   BLACK,  BLACK,  BLUE,   BLUE,     BLUE, 	 BLACK,  BLACK, BLACK, BLUE,    BLUE,   BLUE,    BLUE,       BLUE,      BLACK,    BLUE,    BLUE,     BLACK,     BLUE,     BLUE,     BLACK,    BLACK,     BLUE,     BLUE,     BLUE,     BLUE,     BLACK];

	    color = function( code ){
			parseIt = function( color, code) {
				var isColored = 0;
				var out = ""
				for(var i = 0 ; i < code.length ; i++) {  
					if( color[i] && !isColored ) {
						out += "<span  style=\"color: #" + colors[color[i]] +";\">";
						isColored=1;
					}
					if( !color[i] && isColored ) {
						out += "</span>";
						isColored = 0;
					}
					out += code.charAt(i);
				}
				return out;
			}
			var color = new Array( code.length );
			//   Chaine litérale
			{
				var strLit = 0;
				while( strLit++ < code.length ) {
					if( code.charAt(strLit) == '"' && code.charAt(strLit-1) != '\\') {
						var ok = 0;
						color[strLit] = 1;
						do {
							strLit++;
							color[strLit] = 1;
						}while( code.charAt(strLit) != '"' || code.charAt(strLit-1) == '\\');
					}
				}
			}
			// Caractère litérale
			{
				var strLit = 0;
				while( strLit++ < code.length ) {
					if( code.charAt(strLit) == "'" && code.charAt(strLit-1) != '\\') {
						var ok = 0;
						color[strLit] = 1;
						do {
							strLit++;
							color[strLit] = 1;
						}while( code.charAt(strLit) != "'" || code.charAt(strLit-1) == '\\');
					}
				}
			}
			// Nombre Magique
			{
			    haveInHH = function( str, c ) {
					var i = 0;
					for( i = 0 ; i < str.length ; ++i) {
						if( str.charAt(i) == c) {
							return true;
						}
					}
					return false;
				}
				var nbM = 0;
				while( nbM < code.length  ) {
					if( haveInHH("0123456789", code.charAt(nbM)) ) {
						if( code.charAt(nbM) == '0' ) {
							if( (	code.charAt(nbM+1) == 'x' ||
									code.charAt(nbM+1) == 'X' ) && 
									 ~("ABCDEFabcdef0123456789".indexOf(code.charAt(nbM))) ) {
									// Hexadecimal
										color[nbM++] = 4; 
										color[nbM++] = 4;            
									while( ~("ABCDEFabcdef0123456789".indexOf(code.charAt(nbM))) ) {
										color[nbM++] = 4;   
									}
							}
							else {
								// Octal        
								while( ~("01234567".indexOf(code.charAt(nbM))) ) {
									color[nbM++] = 4; 
								}
							}
						} else {
							// Digital
							while(  ~("0123456789".indexOf(code.charAt(nbM))) ) {
								color[nbM++] = 4; 
							}
						}
						nbM++;
					} else {
						nbM++;
					}
				}
			}
			// Commentaire ligne
			{
				var cmtUL = 0;
				while( cmtUL < code.length ) {
					if(  code.charAt(cmtUL) == '/' && code.charAt(cmtUL+1) == '/' ) {
						do {
							color[cmtUL++] = 2; 
						}while( code.charAt(cmtUL) != '\n' && cmtUL < code.length );
					}
					cmtUL++;
				}
			}
			// Directive Préprocesseur
			{
				var cmtUL = 0;
				while( cmtUL < code.length ) {
					if(  code.charAt(cmtUL) == '#' && !color[cmtUL] ) {
						color[cmtUL] = 3;
						do {
							color[cmtUL++] = 3; 
						}
						while( code.charAt(cmtUL) != '\n' && cmtUL < code.length );
					}
					cmtUL++;
				}
			}
			// Commentaire multilgne
			{
				var MLcmt = 0;
				do {
					if( code.charAt(MLcmt) == '/' && code.charAt(MLcmt+1) == '*') {
						color[MLcmt] = 2;
						do {
							color[MLcmt++] = 2;
						}while( code.charAt(MLcmt) != '/' || code.charAt(MLcmt-1) != '*' && MLcmt < code.length );
						color[MLcmt] = 2;
						
					}
					MLcmt++;
				}while( MLcmt < code.length );
			}
			// Keyword 
			{
				var keyW = 0;
				while( keyW < code.length )  {
					if( !~("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".indexOf(code.charAt(keyW))) && ~("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".indexOf(code.charAt(keyW+1))) ) {
						var someWord = -1, i = 0;
						keyW++;
						for(i = 0 ; i < keysWords.length ; ++i) {
							if( keysWords[i] == code.substring(keyW, keyW+keysWords[i].length) ) {
								if(!~("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".indexOf(code.charAt(keyW+keysWords[i].length)))) {
									someWord = i;
								}
								break;
							}
						}
						if( someWord >= 0) {
							for(var i = 0 ; i < keysWords[someWord].length ; ++i) {
								color[keyW+i] = colorKW[someWord]; 
							}
						}
					}
					keyW++;
				}
			}
			return parseIt(color, code);
		}
		while( ~str.indexOf("&lt;code&gt;")) {
			var fstr = str.substring(0, str.indexOf("&lt;code&gt;"));
			str = str.substring(str.indexOf("&lt;code&gt;")+12);
			var lstr = str.substring(str.indexOf("&lt;/code&gt;")+13);
			var code = str.substring(0, str.indexOf("&lt;/code&gt;"));
			code = code.replace( /<br>/gi, "\n");
			code = color(code);
			var nbL = 0, i;
			for( i = 0 ; i < code.length ; i++) {
			  if( code.charAt(i) == '\n' ) {
			    nbL++;
			  }
			}
			code = code.replace( /\n/g, "<br>");
			
			var ligne = '<code style="float: left;font-family: monospace;line-height: 15px;font-size: 12px">', tmpmL = nbL+"";
			for(i = 1 ; i <= nbL+1 ; i++) {
			  var line = ""+i;
			  while (line.length < tmpmL.length ) {
			    line += ' ';
			  }
			  line += '|<br>';
			  ligne+= line;
			}
			ligne += '</code>'
			
			str = fstr + '<pre>' + ligne + '<code style="font-family: monospace; line-height: 12px; font-size: 12px;">' + code + '</code></pre>' + lstr;
		}
		
		return str;
	},
	init  :  function() {
		var appcontent = document.getElementById("appcontent"); 
		if (appcontent) {
			appcontent.addEventListener("DOMContentLoaded", function(e) {
				var doc = e.originalTarget, href;
				zMembre.doc = doc;
				if (e.originalTarget.nodeName === "#document") {
					if (doc.location.href.indexOf("siteduzero.") != -1) {
						//doc.getElementById("beta").setAttribute("hidden", "checked ");
						var showCodeBoutton = doc.createElement('button');
						showCodeBoutton.setAttribute('type', 'button');
						showCodeBoutton.addEventListener("click", function() {
						   var str = zMembre.getSrc(doc.getElementById('Comment_wysiwyg_message_ifr').contentDocument.body.innerHTML);
						   doc.getElementById('Comment_wysiwyg_message_ifr').contentDocument.body.innerHTML = str;
						}, true);
						var newBouttonText = doc.createTextNode("Colorer le code");
						showCodeBoutton.appendChild(newBouttonText);
						doc.getElementById('newComment').appendChild(showCodeBoutton);
					}
				}
			}, true);
		}
	}
  };
  window.addEventListener("load", function() { zMembre.init(); }, false);
};
